#include "CPU_AI.h"
#include "Board.h"

typedef struct val_struct{
	int cpuX_second;
	int cpuY_second;
	int playerX;
	int playerY;
	int valX;
	int valY;
	int cpu_val_point_first;
	int player_val_point_first;
	int cpu_val_point_second;
	int total;
	int player_val_point_save;
	int cpu_val_point_save;
}val_struct;

//vg^Cv錾
static int CPU_AI(int,int);
static void Check_val_point(int,int,val_struct *p_valst,int);

//CPU̓͊֐
int CPU_input(int Tekikoma){

	int end = 0;
	int cpuX,cpuY,playerX,playerY,cpuX_second,cpuY_second;
	int Mykoma;
	int level = 0;

	val_struct valstruct ={0,0,0,0,0,0,-100,-100,-100,-500,-100,200};

	int search_count = 0;			//v[[pXǂfϐ
	int search_count_second = 0;

	if(Tekikoma == BLACK){
		Mykoma = WHITE;
	}else{
		Mykoma = BLACK;
	}

	for( cpuY = 1 ; cpuY < BAN_HEIGHT -1 ; cpuY++ ){					//WÂT[`֐֑
		for( cpuX = 1 ; cpuX < BAN_WIDTH -1 ; cpuX++ ){
			//  ŏ̏Ԃۑ
            Board_CPU_BanData_push();
			if(Board_Search(cpuX,cpuY,Tekikoma) >= 1){
				//R}ԂAi񂾏Ԃɂ
				Board_Flip(Tekikoma);
				level = 0;
				valstruct.player_val_point_save = -100;
				valstruct.cpu_val_point_save = 200;
				Check_val_point(cpuX,cpuY,&valstruct,level);
				search_count = 0;
				for( playerY = 1;  playerY < BAN_HEIGHT -1 ; playerY++ ){		//WÂT[`֐֑
					for( playerX = 1 ; playerX < BAN_WIDTH -1 ; playerX++ ){
						//i񂾏Ԃ̃{[hۑ
						Board_CPU_BanData_push();	
						//̏ԂŃv[[̃R}uꏊz
						if(Board_Search(playerX,playerY,Mykoma) >= 1){
							search_count++;
							level = 1;
							Check_val_point(playerX,playerY,&valstruct,level);		//z̍ő]lT
							printf("Ă邩playerX:%d,Y:%d\n",playerX,playerY);
						}
						//{[h̏߂
						Board_CPU_BanData_pop();	
					}
				}
				if(Board_Search(valstruct.playerX,valstruct.playerY,Mykoma) >= 1){		//z肪ł]l̍ꏊɒuƑz
					Board_Flip(Mykoma);
					for( cpuY_second = 1 ; cpuY_second < BAN_HEIGHT -1 ; cpuY_second++ ){					//WÂT[`֐֑
						for( cpuX_second = 1 ; cpuX_second < BAN_WIDTH -1 ; cpuX_second++ ){
							//  ŏ̏Ԃۑ
							Board_CPU_BanData_push();
							if(Board_Search(cpuX_second,cpuY_second,Tekikoma) >= 1){
								level = 2;
								search_count_second++;
								Check_val_point(cpuX_second,cpuY_second,&valstruct,level);		//Oڂ̒uꏊi]l̏ꏊj
							}
							//{[h̏߂
							Board_CPU_BanData_pop();
						}
					}	
					level = 3;
					Check_val_point(cpuX,cpuY,&valstruct,level);	//W̍ŏI
				}
				if(search_count == 0){
					valstruct.total = 300,	//v[[pXIȌ󋵂̂߁Atotal̒lőɂĂ̍WɃR}uĂ܂
					valstruct.valY = cpuY, valstruct.valX = cpuX;			
				}
				if(search_count == 0){
					valstruct.total = 300,
					valstruct.valY = cpuY, valstruct.valX = cpuX;
				}
			}
			//Flip֐ɂĐi񂾃{[hÃ{[h̏Ԃɖ߂
			Board_CPU_BanData_pop();				
		}
	}
	WaitTimer( 1000 );										//vlԂ1b

	printf("ŏIvalX:%d,valY:%d\n",valstruct.valX,valstruct.valY);
	if(Board_Search(valstruct.valX, valstruct.valY, Tekikoma) >= 1){			//]l̈ԍWɃR}u
		Board_Flip(Tekikoma),								//R}Ԃ
		end = 1;
	}
	return end; 
}

//CPUAI֐
static int CPU_AI(int x,int y){
	int val_point = 0;

	int val_table[BAN_HEIGHT][BAN_WIDTH] =					//]z
	{  
		{-100,-100,-100,-100,-100,-100,-100,-100,-100,-100},
		{-100,100, -20,  20,   5,   5,  20, -20, 100, -100},  
		{-100,-20, -40,  -5,  -5,  -5,  -5, -40, -20, -100},  
		{-100, 20,  -5,  15,   3,   3,  15,  -5,  20, -100},  
		{-100,  5,  -5,   3,   3,   3,   3,  -5,   5, -100},  
		{-100,  5,  -5,   3,   3,   3,   3,  -5,   5, -100},  
		{-100, 20,  -5,  15,   3,   3,  15,  -5,  20, -100},  
		{-100,-20, -40,  -5,  -5,  -5,  -5, -40, -20, -100},  
		{-100,100, -20,  20,   5,   5,  20, -20, 100, -100},
		{-100,-100,-100,-100,-100,-100,-100,-100,-100,-100}
	};

	val_point = val_table[y][x];							//]lۑ
	return val_point;										//]lԂ
}

void Check_val_point(int x,int y,val_struct *p_valst,int level){
	
	if(level == 0){
		//uꏊ̍W]֐֑
		p_valst->cpu_val_point_first = CPU_AI(x,y);
	}else if(level == 1){
		//̒uW𑗂ԑ傫lc
		p_valst->player_val_point_first = CPU_AI(x,y);
		if(p_valst->player_val_point_save < p_valst->player_val_point_first){
			p_valst->player_val_point_save = p_valst->player_val_point_first;
			p_valst->playerX = x,p_valst->playerY = y;
			printf("rplayerX:%d,playerY:%d,val_point:%d\n",p_valst->playerX,p_valst->playerY,p_valst->player_val_point_first);
		}
	}else if(level == 2){
		//uꏊ̍W]֐֑Aԏlc
		p_valst->cpu_val_point_second = CPU_AI(x,y);
		if(p_valst->cpu_val_point_save > p_valst->cpu_val_point_second){
			p_valst->cpu_val_point_save = p_valst->cpu_val_point_second;
			p_valst->cpuX_second = x,p_valst->cpuY_second = y;
		}
	}else{
		printf("֐cpuX:%d,cpuY:%d,playerX:%d,playerY:%d\n",x,y,p_valst->playerX,p_valst->playerY);
		printf("֐cpu1:%d,player1:%d,cpu2:%d\n",p_valst->cpu_val_point_first,p_valst->player_val_point_first,p_valst->cpu_val_point_second);
		//l肵Ȃ߁Aēx]l̐ݒ
		p_valst->player_val_point_first = CPU_AI(p_valst->playerX,p_valst->playerY);
		p_valst->cpu_val_point_second = CPU_AI(p_valst->cpuX_second ,p_valst->cpuY_second);
		//ځ[ځ{Oڂ̑]ꏊŏIƂ
		if(p_valst->total < (p_valst->cpu_val_point_first - p_valst->player_val_point_first + p_valst->cpu_val_point_second)){			//]Bl傫΍XV
			p_valst->total = p_valst->cpu_val_point_first - p_valst->player_val_point_first + p_valst->cpu_val_point_second,
			p_valst->valY = y, p_valst->valX = x;					//]W̍XV
			printf("֐cpu1:%d,player1:%d,cpu2:%d\n",p_valst->cpu_val_point_first,p_valst->player_val_point_first,p_valst->cpu_val_point_second);
			}
	}
}